import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
const salesReceipt = await conductor.qbd.salesReceipts.retrieve('123ABC-1234567890', {
conductorEndUserId: 'end_usr_1234567abcdefg',
});
console.log(salesReceipt.id);
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
sales_receipt = conductor.qbd.sales_receipts.retrieve(
id="123ABC-1234567890",
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(sales_receipt.id)
IMPORTANT: If you need to fetch multiple specific sales receipts by ID, use the list endpoint instead with the ids parameter. It accepts an array of IDs so you can batch the request into a single call, which is significantly faster.
GET
/
quickbooks-desktop
/
sales-receipts
/
{id}
JavaScript
import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
const salesReceipt = await conductor.qbd.salesReceipts.retrieve('123ABC-1234567890', {
conductorEndUserId: 'end_usr_1234567abcdefg',
});
console.log(salesReceipt.id);
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
sales_receipt = conductor.qbd.sales_receipts.retrieve(
id="123ABC-1234567890",
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(sales_receipt.id)
The date and time when this sales receipt was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.
The date and time when this sales receipt was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.
The current QuickBooks-assigned revision number of this sales receipt object, which changes each time the object is modified. When updating this object, you must provide the most recent revisionNumber to ensure you're working with the latest data; otherwise, the update will return an error.
The sales receipt's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales receipt's line items unless overridden at the line item level.
The case-sensitive user-defined reference number for this sales receipt, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.
The date by which this sales receipt must be paid, in ISO 8601 format (YYYY-MM-DD).
NOTE: For sales receipts, this field is often null because sales receipts are generally used for point-of-sale payments, where full payment is received at the time of purchase.
The origin location from where the product associated with this sales receipt is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term "FOB" for this field, which stands for "freight on board". This field is informational and has no accounting implications.
The subtotal of this sales receipt, which is the sum of all sales receipt lines before taxes and payments are applied, represented as a decimal string.
The sales-tax item used to calculate the actual tax amount for this sales receipt's transactions by applying a specific tax rate collected for a single tax agency. Unlike salesTaxCode, which only indicates general taxability, this field drives the actual tax calculation and reporting.
For sales receipts, while using this field to specify a single tax item/group that applies uniformly is recommended, complex tax scenarios may require alternative approaches. In such cases, you can set this field to a 0% tax item (conventionally named "Tax Calculated On Invoice") and handle tax calculations through line items instead. When using line items for taxes, note that only individual tax items (not tax groups) can be used, subtotals can help apply a tax to multiple items but only the first tax line after a subtotal is calculated automatically (subsequent tax lines require manual amounts), and the rate column will always display the actual tax amount rather than the rate percentage.
Show child attributes
Example:
{
"id": "80000001-1234567890",
"fullName": "State Sales Tax"
}
The sales receipt's currency. For built-in currencies, the name and code are standard ISO 4217 international values. For user-defined currencies, all values are editable.
The market exchange rate between this sales receipt's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).
The sales-tax code for this sales receipt, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.
Default codes include "Non" (non-taxable) and "Tax" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the "Do You Charge Sales Tax?" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.
A built-in custom field for additional information specific to this sales receipt. Unlike the user-defined fields in the customFields array, this is a standard QuickBooks field that exists for all sales receipts for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike otherCustomField1 and otherCustomField2, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.
A globally unique identifier (GUID) you, the developer, can provide for tracking this object in your external system. This field is immutable and can only be set during object creation.
The custom fields for the sales receipt object, added as user-defined data extensions, not included in the standard QuickBooks object.
Show child attributes
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Conductor Docs","colors":{"primary":"#9563FF","light":"#AE87FF","dark":"#0D001D"},"logo":{"light":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/light.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=43ebf17eb46ef6256a508d4fac23b3bf","dark":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/dark.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=dbd4c90195fb31cbae682dd4bfb98350","href":"https://conductor.is"},"favicon":"https://mintcdn.com/conductor/79gIlu1T1D-ycZhm/favicon.png?fit=max\u0026auto=format\u0026n=79gIlu1T1D-ycZhm\u0026q=85\u0026s=52c2193ef1a37fb3c2a843f148178e26","api":{"openapi":"openapi.documented.yml","playground":{"display":"interactive"}},"background":{"color":{"dark":"#090014"}},"navbar":{"links":[{"href":"mailto:support@conductor.is?subject=Conductor Help","label":"Support"},{"href":"https://dashboard.conductor.is","label":"Dashboard"}],"primary":{"type":"button","label":"Sign up","href":"https://dashboard.conductor.is/sign-up"}},"footer":{"socials":{"twitter":"https://twitter.com/conductor_is","github":"https://github.com/conductor-is","linkedin":"https://linkedin.com/company/conductor-is"},"links":[{"header":"Product","items":[{"label":"Core","href":"https://conductor.is/"},{"label":"FAQ","href":"https://docs.conductor.is/faq"},{"label":"Security","href":"https://docs.conductor.is/security"},{"label":"Testimonials","href":"https://conductor.is/"},{"label":"Pricing","href":"https://conductor.is/"}]},{"header":"Resources","items":[{"label":"Documentation","href":"https://docs.conductor.is"},{"label":"Help Center","href":"https://docs.conductor.is/help"},{"label":"Status","href":"https://status.conductor.is"},{"label":"Quickstart","href":"https://docs.conductor.is/quickstart"}]},{"header":"Company","items":[{"label":"About","href":"https://conductor.is/company"},{"label":"Values","href":"https://conductor-io.notion.site/Conductor-s-Values-83e9eb6e4e4d40a2973b24513dc60f99?pvs=4"},{"label":"Contact","href":"mailto:support@conductor.is?subject=Conductor Help"}]},{"header":"Legal","items":[{"label":"Privacy Policy","href":"https://conductor.is/privacy"},{"label":"Terms of Service","href":"https://conductor.is/terms"},{"label":"Trust Center","href":"https://trust.conductor.is"}]}]},"styling":{"codeblocks":"system","latex":false},"integrations":{"ga4":{"measurementId":"G-X8MDB0LXNF"}},"contextual":{"options":["copy","view","chatgpt","claude"],"display":"header"},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"conductor","hasAudioNarration":false,"actualSubdomain":"conductor","customDomains":["docs.conductor.is"],"gitSource":{"type":"github","owner":"conductor-is","repo":"conductor","deployBranch":"main","contentDirectory":"apps/docs","isPrivate":false,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6ae11a7f65adabf70d2061d0","collectionId":"b2a63ed3-b083-43bc-b0c4-d3ccac3d7db2","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6ae11a7f65adabf70d2061d0"},"feedback":{"edits":false},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6ae11a7f65adabf70d2061d0","clientVersion":"0.0.3990","searchFilterCounts":[{"language":"default","tag":"API Reference","count":337},{"language":"default","tag":"Transactions","count":160},{"language":"default","tag":"General","count":104},{"language":"default","tag":"Items","count":53},{"language":"default","tag":"Help","count":25},{"language":"default","tag":"Documentation","count":15},{"language":"default","tag":"Guides","count":14},{"language":"default","tag":"Reports","count":11},{"language":"default","tag":"QuickBooks Desktop API","count":10},{"language":"default","tag":"Connection errors","count":9}]},"assistantConfig":{},"basePath":"","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"isAtlas":false,"googleFontsInlined":false},"customCss":[],"page":{"pagePath":"api-ref/qbd/sales-receipts/retrieve","slug":"/api-ref/qbd/sales-receipts/retrieve","pageMetadata":{"openapi":"GET /quickbooks-desktop/sales-receipts/{id}","title":"Retrieve a sales receipt","description":"Retrieves a sales receipt by ID.\n\n**IMPORTANT:** If you need to fetch multiple specific sales receipts by ID, use the list endpoint instead with the `ids` parameter. It accepts an array of IDs so you can batch the request into a single call, which is significantly faster.","href":"/api-ref/qbd/sales-receipts/retrieve"},"description":{"compiledSource":"\"use strict\";\nconst {Fragment: _Fragment, jsx: _jsx, jsxs: _jsxs} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n code: \"code\",\n p: \"p\",\n strong: \"strong\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsxs(_Fragment, {\n children: [_jsx(_components.p, {\n children: \"Retrieves a sales receipt by ID.\"\n }), \"\\n\", _jsxs(_components.p, {\n children: [_jsx(_components.strong, {\n children: \"IMPORTANT:\"\n }), \" If you need to fetch multiple specific sales receipts by ID, use the list endpoint instead with the \", _jsx(_components.code, {\n children: \"ids\"\n }), \" parameter. It accepts an array of IDs so you can batch the request into a single call, which is significantly faster.\"]\n })]\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"codeStyling":"system","config":{},"pageMetadata":{"openapi":"GET /quickbooks-desktop/sales-receipts/{id}","title":"Retrieve a sales receipt","description":"Retrieves a sales receipt by ID.\n\n**IMPORTANT:** If you need to fetch multiple specific sales receipts by ID, use the list endpoint instead with the `ids` parameter. It accepts an array of IDs so you can batch the request into a single call, which is significantly faster.","href":"/api-ref/qbd/sales-receipts/retrieve"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"summary":"Retrieve a sales receipt","description":"Retrieves a sales receipt by ID.\n\n**IMPORTANT:** If you need to fetch multiple specific sales receipts by ID, use the list endpoint instead with the `ids` parameter. It accepts an array of IDs so you can batch the request into a single call, which is significantly faster.","security":["d483be2d-525a-4980-b228-d13c9d3dbfe8"],"parameters":["2ab51262-ab06-41c5-a91f-997477cc82ea","6857532c-9535-4997-8660-fa7215bf71a3"],"responses":{"200":"d4f30425-ac38-420d-8aa2-7bb23295251a"},"x-codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\nconst salesReceipt = await conductor.qbd.salesReceipts.retrieve('123ABC-1234567890', {\n conductorEndUserId: 'end_usr_1234567abcdefg',\n});\n\nconsole.log(salesReceipt.id);"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\nsales_receipt = conductor.qbd.sales_receipts.retrieve(\n id=\"123ABC-1234567890\",\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\nprint(sales_receipt.id)"}],"method":"get","type":"path","servers":["045cea4d-dfb6-46e4-9c51-52452b7b239b"],"path":"/quickbooks-desktop/sales-receipts/{id}","baseUrlOptions":["https://api.conductor.is/v1"],"title":"Retrieve a sales receipt","codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\nconst salesReceipt = await conductor.qbd.salesReceipts.retrieve('123ABC-1234567890', {\n conductorEndUserId: 'end_usr_1234567abcdefg',\n});\n\nconsole.log(salesReceipt.id);"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\nsales_receipt = conductor.qbd.sales_receipts.retrieve(\n id=\"123ABC-1234567890\",\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\nprint(sales_receipt.id)"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"2ab51262-ab06-41c5-a91f-997477cc82ea":{"in":"header","name":"Conductor-End-User-Id","schema":{"type":"string","description":"The ID of the End-User to receive this request.","example":"end_usr_1234567abcdefg","x-stainless-naming":{"typescript":{"method_argument":"conductorEndUserId"},"mcp":{"method_argument":"conductorEndUserId"}},"isRequired":true,"uniqueKey":"","typeLabel":"string"},"required":true,"description":"The ID of the End-User to receive this request."},"6857532c-9535-4997-8660-fa7215bf71a3":{"in":"path","name":"id","schema":{"type":"string","maxLength":36,"description":"The QuickBooks-assigned unique identifier of the sales receipt to retrieve.","example":"123ABC-1234567890","isRequired":true,"uniqueKey":"","typeLabel":"string"},"required":true,"description":"The QuickBooks-assigned unique identifier of the sales receipt to retrieve."}},"responses":{"d4f30425-ac38-420d-8aa2-7bb23295251a":{"description":"Returns the specified sales receipt.","headers":{"Conductor-Request-Id":{"required":true,"description":"The unique identifier for this API request.","schema":{"type":"string","description":"The unique identifier for this API request.","example":"req_1234567abcdefg"}}},"content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier assigned by QuickBooks to this sales receipt. This ID is unique across all transaction types.","example":"123ABC-1234567890","isRequired":true,"uniqueKey":"id","typeLabel":"string"},"objectType":{"description":"The type of object. This value is always `\"qbd_sales_receipt\"`.","example":"qbd_sales_receipt","type":"string","const":"qbd_sales_receipt","isRequired":true,"uniqueKey":"objectType","typeLabel":"string"},"createdAt":{"type":"string","description":"The date and time when this sales receipt was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-01-01T12:34:56.000Z","isRequired":true,"uniqueKey":"createdAt","typeLabel":"string"},"updatedAt":{"type":"string","description":"The date and time when this sales receipt was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-02-01T12:34:56.000Z","isRequired":true,"uniqueKey":"updatedAt","typeLabel":"string"},"revisionNumber":{"type":"string","description":"The current QuickBooks-assigned revision number of this sales receipt object, which changes each time the object is modified. When updating this object, you must provide the most recent `revisionNumber` to ensure you're working with the latest data; otherwise, the update will return an error.","example":"1721172183","isRequired":true,"uniqueKey":"revisionNumber","typeLabel":"string"},"customer":{"oneOf":[{"type":"object","description":"The customer or customer-job to which the payment for this sales receipt is credited.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Acme Corporation"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customer.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customer.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customer.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customer.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"customer.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer or customer-job to which the payment for this sales receipt is credited.","example":{"id":"80000001-1234567890","fullName":"Acme Corporation"},"isRequired":true,"uniqueKey":"customer.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer","typeLabel":"object | null"},"class":{"oneOf":[{"type":"object","description":"The sales receipt's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales receipt's line items unless overridden at the line item level.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Retail Sales"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"class.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"class.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"class.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"class.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"class.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales receipt's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales receipt's line items unless overridden at the line item level.","example":{"id":"80000001-1234567890","fullName":"Retail Sales"},"isRequired":true,"uniqueKey":"class.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class","typeLabel":"object | null"},"documentTemplate":{"oneOf":[{"type":"object","description":"The predefined template in QuickBooks that determines the layout and formatting for this sales receipt when printed or displayed.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Sales Receipt Template"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0","typeLabel":"object"},{"type":"null","description":"The predefined template in QuickBooks that determines the layout and formatting for this sales receipt when printed or displayed.","example":{"id":"80000001-1234567890","fullName":"Sales Receipt Template"},"isRequired":true,"uniqueKey":"documentTemplate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate","typeLabel":"object | null"},"transactionDate":{"type":"string","format":"date","description":"The date of this sales receipt, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01","isRequired":true,"uniqueKey":"transactionDate","typeLabel":"string\u003cdate>"},"refNumber":{"oneOf":[{"type":"string","description":"The case-sensitive user-defined reference number for this sales receipt, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.","example":"RECEIPT-1234","isRequired":true,"uniqueKey":"refNumber.oneOf.0","typeLabel":"string"},{"type":"null","description":"The case-sensitive user-defined reference number for this sales receipt, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.","example":"RECEIPT-1234","isRequired":true,"uniqueKey":"refNumber.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"refNumber","typeLabel":"string | null"},"billingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The sales receipt's billing address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"billingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The sales receipt's billing address.","isRequired":true,"uniqueKey":"billingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress","typeLabel":"The Address object · object | null"},"shippingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The sales receipt's shipping address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The sales receipt's shipping address.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress","typeLabel":"The Address object · object | null"},"isPending":{"oneOf":[{"type":"boolean","description":"Indicates whether this sales receipt has not been completed.","example":false,"isRequired":true,"uniqueKey":"isPending.oneOf.0","typeLabel":"boolean"},{"type":"null","description":"Indicates whether this sales receipt has not been completed.","example":false,"isRequired":true,"uniqueKey":"isPending.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"isPending","typeLabel":"boolean | null"},"checkNumber":{"oneOf":[{"type":"string","description":"The check number of a check received for this sales receipt.","example":"1234567890","isRequired":true,"uniqueKey":"checkNumber.oneOf.0","typeLabel":"string"},{"type":"null","description":"The check number of a check received for this sales receipt.","example":"1234567890","isRequired":true,"uniqueKey":"checkNumber.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"checkNumber","typeLabel":"string | null"},"paymentMethod":{"oneOf":[{"type":"object","description":"The sales receipt's payment method (e.g., cash, check, credit card).","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Credit Card"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"paymentMethod.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"paymentMethod.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales receipt's payment method (e.g., cash, check, credit card).","example":{"id":"80000001-1234567890","fullName":"Credit Card"},"isRequired":true,"uniqueKey":"paymentMethod.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"paymentMethod","typeLabel":"object | null"},"dueDate":{"oneOf":[{"type":"string","description":"The date by which this sales receipt must be paid, in ISO 8601 format (YYYY-MM-DD).\n\n**NOTE**: For sales receipts, this field is often `null` because sales receipts are generally used for point-of-sale payments, where full payment is received at the time of purchase.","format":"date","example":"2024-10-31T00:00:00.000Z","isRequired":true,"uniqueKey":"dueDate.oneOf.0","typeLabel":"string\u003cdate>"},{"type":"null","description":"The date by which this sales receipt must be paid, in ISO 8601 format (YYYY-MM-DD).\n\n**NOTE**: For sales receipts, this field is often `null` because sales receipts are generally used for point-of-sale payments, where full payment is received at the time of purchase.","example":"2024-10-31T00:00:00.000Z","isRequired":true,"uniqueKey":"dueDate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"dueDate","typeLabel":"string\u003cdate> | null"},"salesRepresentative":{"oneOf":[{"type":"object","description":"The sales receipt's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales receipt's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative","typeLabel":"object | null"},"shippingDate":{"oneOf":[{"type":"string","description":"The date when the products or services for this sales receipt were shipped or are expected to be shipped, in ISO 8601 format (YYYY-MM-DD).","format":"date","example":"2024-10-01T00:00:00.000Z","isRequired":true,"uniqueKey":"shippingDate.oneOf.0","typeLabel":"string\u003cdate>"},{"type":"null","description":"The date when the products or services for this sales receipt were shipped or are expected to be shipped, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01T00:00:00.000Z","isRequired":true,"uniqueKey":"shippingDate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingDate","typeLabel":"string\u003cdate> | null"},"shippingMethod":{"oneOf":[{"type":"object","description":"The shipping method used for this sales receipt, such as standard mail or overnight delivery.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"FedEx Ground"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0","typeLabel":"object"},{"type":"null","description":"The shipping method used for this sales receipt, such as standard mail or overnight delivery.","example":{"id":"80000001-1234567890","fullName":"FedEx Ground"},"isRequired":true,"uniqueKey":"shippingMethod.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod","typeLabel":"object | null"},"shipmentOrigin":{"oneOf":[{"type":"string","description":"The origin location from where the product associated with this sales receipt is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term \"FOB\" for this field, which stands for \"freight on board\". This field is informational and has no accounting implications.","example":"San Francisco, CA","isRequired":true,"uniqueKey":"shipmentOrigin.oneOf.0","typeLabel":"string"},{"type":"null","description":"The origin location from where the product associated with this sales receipt is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term \"FOB\" for this field, which stands for \"freight on board\". This field is informational and has no accounting implications.","example":"San Francisco, CA","isRequired":true,"uniqueKey":"shipmentOrigin.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shipmentOrigin","typeLabel":"string | null"},"subtotal":{"type":"string","description":"The subtotal of this sales receipt, which is the sum of all sales receipt lines before taxes and payments are applied, represented as a decimal string.","example":"1000.00","isRequired":true,"uniqueKey":"subtotal","typeLabel":"string"},"salesTaxItem":{"oneOf":[{"type":"object","description":"The sales-tax item used to calculate the actual tax amount for this sales receipt's transactions by applying a specific tax rate collected for a single tax agency. Unlike `salesTaxCode`, which only indicates general taxability, this field drives the actual tax calculation and reporting.\n\nFor sales receipts, while using this field to specify a single tax item/group that applies uniformly is recommended, complex tax scenarios may require alternative approaches. In such cases, you can set this field to a 0% tax item (conventionally named \"Tax Calculated On Invoice\") and handle tax calculations through line items instead. When using line items for taxes, note that only individual tax items (not tax groups) can be used, subtotals can help apply a tax to multiple items but only the first tax line after a subtotal is calculated automatically (subsequent tax lines require manual amounts), and the rate column will always display the actual tax amount rather than the rate percentage.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"State Sales Tax"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales-tax item used to calculate the actual tax amount for this sales receipt's transactions by applying a specific tax rate collected for a single tax agency. Unlike `salesTaxCode`, which only indicates general taxability, this field drives the actual tax calculation and reporting.\n\nFor sales receipts, while using this field to specify a single tax item/group that applies uniformly is recommended, complex tax scenarios may require alternative approaches. In such cases, you can set this field to a 0% tax item (conventionally named \"Tax Calculated On Invoice\") and handle tax calculations through line items instead. When using line items for taxes, note that only individual tax items (not tax groups) can be used, subtotals can help apply a tax to multiple items but only the first tax line after a subtotal is calculated automatically (subsequent tax lines require manual amounts), and the rate column will always display the actual tax amount rather than the rate percentage.","example":{"id":"80000001-1234567890","fullName":"State Sales Tax"},"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem","typeLabel":"object | null"},"salesTaxPercentage":{"oneOf":[{"type":"string","description":"The sales tax percentage applied to this sales receipt, represented as a decimal string.","example":"0.07","isRequired":true,"uniqueKey":"salesTaxPercentage.oneOf.0","typeLabel":"string"},{"type":"null","description":"The sales tax percentage applied to this sales receipt, represented as a decimal string.","example":"0.07","isRequired":true,"uniqueKey":"salesTaxPercentage.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxPercentage","typeLabel":"string | null"},"salesTaxTotal":{"oneOf":[{"type":"string","description":"The total amount of sales tax charged for this sales receipt, represented as a decimal string.","example":"10.00","isRequired":true,"uniqueKey":"salesTaxTotal.oneOf.0","typeLabel":"string"},{"type":"null","description":"The total amount of sales tax charged for this sales receipt, represented as a decimal string.","example":"10.00","isRequired":true,"uniqueKey":"salesTaxTotal.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxTotal","typeLabel":"string | null"},"totalAmount":{"type":"string","description":"The total monetary amount of this sales receipt, equivalent to the sum of the amounts in `lines` and `lineGroups`, represented as a decimal string.","example":"1000.00","isRequired":true,"uniqueKey":"totalAmount","typeLabel":"string"},"currency":{"oneOf":[{"type":"object","description":"The sales receipt's currency. For built-in currencies, the name and code are standard ISO 4217 international values. For user-defined currencies, all values are editable.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"USD"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"currency.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"currency.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"currency.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"currency.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"currency.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"currency.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"currency.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales receipt's currency. For built-in currencies, the name and code are standard ISO 4217 international values. For user-defined currencies, all values are editable.","example":{"id":"80000001-1234567890","fullName":"USD"},"isRequired":true,"uniqueKey":"currency.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"currency","typeLabel":"object | null"},"exchangeRate":{"oneOf":[{"type":"number","description":"The market exchange rate between this sales receipt's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).","example":1.2345,"isRequired":true,"uniqueKey":"exchangeRate.oneOf.0","typeLabel":"number"},{"type":"null","description":"The market exchange rate between this sales receipt's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).","example":1.2345,"isRequired":true,"uniqueKey":"exchangeRate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"exchangeRate","typeLabel":"number | null"},"totalAmountInHomeCurrency":{"oneOf":[{"type":"string","description":"The total monetary amount of this sales receipt converted to the home currency of the QuickBooks company file. Represented as a decimal string.","example":"1234.56","isRequired":true,"uniqueKey":"totalAmountInHomeCurrency.oneOf.0","typeLabel":"string"},{"type":"null","description":"The total monetary amount of this sales receipt converted to the home currency of the QuickBooks company file. Represented as a decimal string.","example":"1234.56","isRequired":true,"uniqueKey":"totalAmountInHomeCurrency.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"totalAmountInHomeCurrency","typeLabel":"string | null"},"memo":{"oneOf":[{"type":"string","description":"A memo or note for this sales receipt that appears in reports, but not on the sales receipt.","example":"Payment received at store location - cash","isRequired":true,"uniqueKey":"memo.oneOf.0","typeLabel":"string"},{"type":"null","description":"A memo or note for this sales receipt that appears in reports, but not on the sales receipt.","example":"Payment received at store location - cash","isRequired":true,"uniqueKey":"memo.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"memo","typeLabel":"string | null"},"customerMessage":{"oneOf":[{"type":"object","description":"The message to display to the customer on the sales receipt.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Thank you for your business!"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customerMessage.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customerMessage.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customerMessage.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customerMessage.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customerMessage.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customerMessage.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"customerMessage.oneOf.0","typeLabel":"object"},{"type":"null","description":"The message to display to the customer on the sales receipt.","example":{"id":"80000001-1234567890","fullName":"Thank you for your business!"},"isRequired":true,"uniqueKey":"customerMessage.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customerMessage","typeLabel":"object | null"},"isQueuedForPrint":{"oneOf":[{"type":"boolean","description":"Indicates whether this sales receipt is included in the queue of documents for QuickBooks to print.","example":true,"isRequired":true,"uniqueKey":"isQueuedForPrint.oneOf.0","typeLabel":"boolean"},{"type":"null","isRequired":true,"uniqueKey":"isQueuedForPrint.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"isQueuedForPrint","typeLabel":"boolean | null"},"isQueuedForEmail":{"oneOf":[{"type":"boolean","description":"Indicates whether this sales receipt is included in the queue of documents for QuickBooks to email to the customer.","example":true,"isRequired":true,"uniqueKey":"isQueuedForEmail.oneOf.0","typeLabel":"boolean"},{"type":"null","description":"Indicates whether this sales receipt is included in the queue of documents for QuickBooks to email to the customer.","example":true,"isRequired":true,"uniqueKey":"isQueuedForEmail.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"isQueuedForEmail","typeLabel":"boolean | null"},"salesTaxCode":{"oneOf":[{"type":"object","description":"The sales-tax code for this sales receipt, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Non"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"salesTaxCode.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales-tax code for this sales receipt, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","example":{"id":"80000001-1234567890","fullName":"Non"},"isRequired":true,"uniqueKey":"salesTaxCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxCode","typeLabel":"object | null"},"depositToAccount":{"oneOf":[{"type":"object","description":"The account where the funds for this sales receipt will be or have been deposited.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Undeposited Funds"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"depositToAccount.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"depositToAccount.oneOf.0","typeLabel":"object"},{"type":"null","description":"The account where the funds for this sales receipt will be or have been deposited.","example":{"id":"80000001-1234567890","fullName":"Undeposited Funds"},"isRequired":true,"uniqueKey":"depositToAccount.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"depositToAccount","typeLabel":"object | null"},"creditCardTransaction":{"oneOf":[{"type":"object","title":"The Credit Card Transaction object","description":"The credit card transaction data for this sales receipt's payment when using QuickBooks Merchant Services (QBMS).","required":["request","response"],"x-conductor-object-type":"nested","properties":{"request":{"oneOf":[{"type":"object","title":"The Credit Card Transaction Request object","description":"The transaction request data originally supplied for this credit card transaction when using QuickBooks Merchant Services (QBMS).","required":["number","expirationMonth","expirationYear","name","address","postalCode","commercialCardCode","transactionMode","transactionType"],"x-conductor-object-type":"nested","properties":{"number":{"type":"string","description":"The credit card number. Must be masked with lower case \"x\" and no dashes.","example":"xxxxxxxxxxxx1234","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.number","typeLabel":"string"},"expirationMonth":{"type":"number","description":"The month when the credit card expires.","example":12,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.expirationMonth","typeLabel":"number"},"expirationYear":{"type":"number","description":"The year when the credit card expires.","example":2024,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.expirationYear","typeLabel":"number"},"name":{"oneOf":[{"type":"string","description":"The cardholder's name on the card.","example":"John Doe","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.name.oneOf.0","typeLabel":"string"},{"type":"null","description":"The cardholder's name on the card.","example":"John Doe","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.name.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.name","typeLabel":"string | null"},"address":{"oneOf":[{"type":"string","description":"The card's billing address.","example":"1234 Main St, Anytown, USA, 12345","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.address.oneOf.0","typeLabel":"string"},{"type":"null","description":"The card's billing address.","example":"1234 Main St, Anytown, USA, 12345","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.address.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.address","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The card's billing address ZIP or postal code.","example":"12345","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The card's billing address ZIP or postal code.","example":"12345","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.postalCode","typeLabel":"string | null"},"commercialCardCode":{"oneOf":[{"type":"string","description":"The commercial card code identifies the type of business credit card being used (purchase, corporate, or business) for Visa and Mastercard transactions only. When provided, this code may qualify the transaction for lower processing fees compared to the standard rates that apply when no code is specified.","example":"corporate","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.commercialCardCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The commercial card code identifies the type of business credit card being used (purchase, corporate, or business) for Visa and Mastercard transactions only. When provided, this code may qualify the transaction for lower processing fees compared to the standard rates that apply when no code is specified.","example":"corporate","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.commercialCardCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.commercialCardCode","typeLabel":"string | null"},"transactionMode":{"oneOf":[{"type":"string","description":"Indicates whether this credit card transaction came from a card swipe (`card_present`) or not (`card_not_present`).","enum":["card_not_present","card_present"],"example":"card_not_present","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionMode.oneOf.0","typeLabel":"enum\u003cstring>"},{"type":"null","description":"Indicates whether this credit card transaction came from a card swipe (`card_present`) or not (`card_not_present`).","example":"card_not_present","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionMode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionMode","typeLabel":"enum\u003cstring> | null"},"transactionType":{"oneOf":[{"type":"string","description":"The QBMS transaction type from which the current transaction data originated.","enum":["authorization","capture","charge","refund","voice_authorization"],"example":"charge","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionType.oneOf.0","typeLabel":"enum\u003cstring>"},{"type":"null","description":"The QBMS transaction type from which the current transaction data originated.","example":"charge","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionType.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0.transactionType","typeLabel":"enum\u003cstring> | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.0","typeLabel":"The Credit Card Transaction Request object · object"},{"type":"null","description":"The transaction request data originally supplied for this credit card transaction when using QuickBooks Merchant Services (QBMS).","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.request","typeLabel":"The Credit Card Transaction Request object · object | null"},"response":{"oneOf":[{"type":"object","title":"The Credit Card Transaction Response object","description":"The transaction response data for this credit card transaction when using QuickBooks Merchant Services (QBMS).","required":["statusCode","statusMessage","creditCardTransactionId","merchantAccountNumber","authorizationCode","avsStreetStatus","avsZipStatus","cardSecurityCodeMatch","reconBatchId","paymentGroupingCode","paymentStatus","transactionAuthorizedAt","transactionAuthorizationStamp","clientTransactionId"],"x-conductor-object-type":"nested","properties":{"statusCode":{"type":"number","description":"The status code returned in the original QBMS transaction response for this credit card transaction.","example":0,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.statusCode","typeLabel":"number"},"statusMessage":{"type":"string","description":"The status message returned in the original QBMS transaction response for this credit card transaction.","example":"Success","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.statusMessage","typeLabel":"string"},"creditCardTransactionId":{"type":"string","description":"The ID returned from the credit card processor for this credit card transaction.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.creditCardTransactionId","typeLabel":"string"},"merchantAccountNumber":{"type":"string","description":"The QBMS account number of the merchant who is running this transaction using the customer's credit card.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.merchantAccountNumber","typeLabel":"string"},"authorizationCode":{"oneOf":[{"type":"string","description":"The authorization code returned from the credit card processor to indicate that this charge will be paid by the card issuer.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.authorizationCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The authorization code returned from the credit card processor to indicate that this charge will be paid by the card issuer.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.authorizationCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.authorizationCode","typeLabel":"string | null"},"avsStreetStatus":{"oneOf":[{"type":"string","description":"Indicates whether the street address supplied in the transaction request matches the customer's address on file at the card issuer.","enum":["fail","not_available","pass"],"example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsStreetStatus.oneOf.0","typeLabel":"enum\u003cstring>"},{"type":"null","description":"Indicates whether the street address supplied in the transaction request matches the customer's address on file at the card issuer.","example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsStreetStatus.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsStreetStatus","typeLabel":"enum\u003cstring> | null"},"avsZipStatus":{"oneOf":[{"type":"string","description":"Indicates whether the customer postal ZIP code supplied in the transaction request matches the customer's postal code recognized at the card issuer.","enum":["fail","not_available","pass"],"example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsZipStatus.oneOf.0","typeLabel":"enum\u003cstring>"},{"type":"null","description":"Indicates whether the customer postal ZIP code supplied in the transaction request matches the customer's postal code recognized at the card issuer.","example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsZipStatus.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.avsZipStatus","typeLabel":"enum\u003cstring> | null"},"cardSecurityCodeMatch":{"oneOf":[{"type":"string","description":"Indicates whether the card security code supplied in the transaction request matches the card security code recognized for that credit card number at the card issuer.","enum":["fail","not_available","pass"],"example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.cardSecurityCodeMatch.oneOf.0","typeLabel":"enum\u003cstring>"},{"type":"null","description":"Indicates whether the card security code supplied in the transaction request matches the card security code recognized for that credit card number at the card issuer.","example":"pass","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.cardSecurityCodeMatch.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.cardSecurityCodeMatch","typeLabel":"enum\u003cstring> | null"},"reconBatchId":{"oneOf":[{"type":"string","description":"An internal ID returned by QuickBooks Merchant Services (QBMS) from the transaction request, needed for the QuickBooks reconciliation feature.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.reconBatchId.oneOf.0","typeLabel":"string"},{"type":"null","description":"An internal ID returned by QuickBooks Merchant Services (QBMS) from the transaction request, needed for the QuickBooks reconciliation feature.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.reconBatchId.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.reconBatchId","typeLabel":"string | null"},"paymentGroupingCode":{"oneOf":[{"type":"number","description":"An internal code returned by QuickBooks Merchant Services (QBMS) from the transaction request, needed for the QuickBooks reconciliation feature.","example":2,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.paymentGroupingCode.oneOf.0","typeLabel":"number"},{"type":"null","description":"An internal code returned by QuickBooks Merchant Services (QBMS) from the transaction request, needed for the QuickBooks reconciliation feature.","example":2,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.paymentGroupingCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.paymentGroupingCode","typeLabel":"number | null"},"paymentStatus":{"type":"string","enum":["completed","unknown"],"description":"Indicates whether this credit card transaction is known to have been successfully processed by the card issuer.","example":"completed","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.paymentStatus","typeLabel":"enum\u003cstring>"},"transactionAuthorizedAt":{"type":"string","description":"The date and time when the credit card processor authorized this credit card transaction.","example":"2024-01-01T12:34:56.000Z","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.transactionAuthorizedAt","typeLabel":"string"},"transactionAuthorizationStamp":{"oneOf":[{"type":"number","description":"An internal value for this credit card transaction, needed for the QuickBooks reconciliation feature.","example":2,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.transactionAuthorizationStamp.oneOf.0","typeLabel":"number"},{"type":"null","description":"An internal value for this credit card transaction, needed for the QuickBooks reconciliation feature.","example":2,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.transactionAuthorizationStamp.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.transactionAuthorizationStamp","typeLabel":"number | null"},"clientTransactionId":{"oneOf":[{"type":"string","description":"A value returned from QBMS transactions for future use by the QuickBooks Reconciliation feature.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.clientTransactionId.oneOf.0","typeLabel":"string"},{"type":"null","description":"A value returned from QBMS transactions for future use by the QuickBooks Reconciliation feature.","example":"1234567890","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.clientTransactionId.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0.clientTransactionId","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.0","typeLabel":"The Credit Card Transaction Response object · object"},{"type":"null","description":"The transaction response data for this credit card transaction when using QuickBooks Merchant Services (QBMS).","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0.response","typeLabel":"The Credit Card Transaction Response object · object | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.0","typeLabel":"The Credit Card Transaction object · object"},{"type":"null","description":"The credit card transaction data for this sales receipt's payment when using QuickBooks Merchant Services (QBMS).","isRequired":true,"uniqueKey":"creditCardTransaction.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"creditCardTransaction","typeLabel":"The Credit Card Transaction object · object | null"},"otherCustomField":{"oneOf":[{"type":"string","description":"A built-in custom field for additional information specific to this sales receipt. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales receipts for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike `otherCustomField1` and `otherCustomField2`, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.","example":"Special handling required","isRequired":true,"uniqueKey":"otherCustomField.oneOf.0","typeLabel":"string"},{"type":"null","description":"A built-in custom field for additional information specific to this sales receipt. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales receipts for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike `otherCustomField1` and `otherCustomField2`, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.","example":"Special handling required","isRequired":true,"uniqueKey":"otherCustomField.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"otherCustomField","typeLabel":"string | null"},"externalId":{"oneOf":[{"type":"string","description":"A globally unique identifier (GUID) you, the developer, can provide for tracking this object in your external system. This field is immutable and can only be set during object creation.","example":"12345678-abcd-1234-abcd-1234567890ab","isRequired":true,"uniqueKey":"externalId.oneOf.0","typeLabel":"string"},{"type":"null","isRequired":true,"uniqueKey":"externalId.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"externalId","typeLabel":"string | null"},"lines":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier assigned by QuickBooks to this sales receipt line. This ID is unique across all transaction line types.","example":"456DEF-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].id","typeLabel":"string"},"objectType":{"description":"The type of object. This value is always `\"qbd_sales_receipt_line\"`.","example":"qbd_sales_receipt_line","type":"string","const":"qbd_sales_receipt_line","isRequired":true,"uniqueKey":"lines.items.[INDEX].objectType","typeLabel":"string"},"item":{"oneOf":[{"type":"object","description":"The item associated with this sales receipt line. This can refer to any good or service that the business buys or sells, including item types such as a service item, inventory item, or special calculation item like a discount item or sales-tax item.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Widget A"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.0","typeLabel":"object"},{"type":"null","description":"The item associated with this sales receipt line. This can refer to any good or service that the business buys or sells, including item types such as a service item, inventory item, or special calculation item like a discount item or sales-tax item.","example":{"id":"80000001-1234567890","fullName":"Widget A"},"isRequired":true,"uniqueKey":"lines.items.[INDEX].item.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].item","typeLabel":"object | null"},"description":{"oneOf":[{"type":"string","description":"A description of this sales receipt line.","example":"New office chair","isRequired":true,"uniqueKey":"lines.items.[INDEX].description.oneOf.0","typeLabel":"string"},{"type":"null","description":"A description of this sales receipt line.","example":"New office chair","isRequired":true,"uniqueKey":"lines.items.[INDEX].description.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].description","typeLabel":"string | null"},"quantity":{"oneOf":[{"type":"number","description":"The quantity of the item associated with this sales receipt line. This field cannot be cleared.\n\n**NOTE**: Do not use this field if the associated item is a discount item.","example":5,"isRequired":true,"uniqueKey":"lines.items.[INDEX].quantity.oneOf.0","typeLabel":"number"},{"type":"null","description":"The quantity of the item associated with this sales receipt line. This field cannot be cleared.\n\n**NOTE**: Do not use this field if the associated item is a discount item.","example":5,"isRequired":true,"uniqueKey":"lines.items.[INDEX].quantity.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].quantity","typeLabel":"number | null"},"unitOfMeasure":{"oneOf":[{"type":"string","description":"The unit-of-measure used for the `quantity` in this sales receipt line. Must be a valid unit within the item's available units of measure.","example":"Each","isRequired":true,"uniqueKey":"lines.items.[INDEX].unitOfMeasure.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unit-of-measure used for the `quantity` in this sales receipt line. Must be a valid unit within the item's available units of measure.","example":"Each","isRequired":true,"uniqueKey":"lines.items.[INDEX].unitOfMeasure.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].unitOfMeasure","typeLabel":"string | null"},"overrideUnitOfMeasureSet":{"oneOf":[{"type":"object","description":"Specifies an alternative unit-of-measure set when updating this sales receipt line's `unitOfMeasure` field (e.g., \"pound\" or \"kilogram\"). This allows you to select units from a different set than the item's default unit-of-measure set, which remains unchanged on the item itself. The override applies only to this specific line. For example, you can sell an item typically measured in volume units using weight units in a specific transaction by specifying a different unit-of-measure set with this field.\n\nIMPORTANT: Right after QuickBooks Desktop launches, it can briefly report an alternate `id` for a unit-of-measure set, so match on `fullName` when joining to the unit-of-measure sets list.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Volume Units"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.0","typeLabel":"object"},{"type":"null","description":"Specifies an alternative unit-of-measure set when updating this sales receipt line's `unitOfMeasure` field (e.g., \"pound\" or \"kilogram\"). This allows you to select units from a different set than the item's default unit-of-measure set, which remains unchanged on the item itself. The override applies only to this specific line. For example, you can sell an item typically measured in volume units using weight units in a specific transaction by specifying a different unit-of-measure set with this field.\n\nIMPORTANT: Right after QuickBooks Desktop launches, it can briefly report an alternate `id` for a unit-of-measure set, so match on `fullName` when joining to the unit-of-measure sets list.","example":{"id":"80000001-1234567890","fullName":"Volume Units"},"isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSet","typeLabel":"object | null"},"rate":{"oneOf":[{"type":"string","description":"The price per unit for this sales receipt line. If both `rate` and `amount` are specified, `rate` will be ignored. If both `quantity` and `amount` are 
[...]
